Subject: Building with newer Yggdrasil?

From: John Goerzen <[email-masked]>
Date: Thu, 17 Nov 2022 15:08:36 -0600

Hi Sergey,

We finally have gvisor in Debian, so I was looking to build the latest
NNCP for it.  Unfortunately, we now run into another problem, which is
that we have the latest Yggdrasil, and there have been some changes
since the version NNCP is building against.  Namely, these errors occur:

> src/go.cypherpunks.ru/nncp/v8/yggdrasil/yggdrasil.go:89:17: core.Start undefined (type *core.Core has no field or method Start)
> src/go.cypherpunks.ru/nncp/v8/yggdrasil/yggdrasil.go:94:16: mc.Init undefined (type *multicast.Multicast has no field or method Init)
> src/go.cypherpunks.ru/nncp/v8/yggdrasil/yggdrasil.go:98:16: mc.Start undefined (type *multicast.Multicast has no field or method Start)

I'm not a Go programmer, but took a quick look at it.  Looking in the
Yggdrasil git history for lines that include "core.Start", I can see
what they remove and then how they start it instead.  I'm not really up
enough on Go and NNCP to know how to do this translation myself; but my
gut says it would probably be pretty easy for you.  Would you happen to
be able to update NNCP to build against the latest Yggdrasil release,
0.4.6?

Thanks!

- John